<?php
/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

define( '_VALID_OSM', TRUE );
define( '_PATH', './' );
$DEBUG = FALSE;
if($DEBUG) error_reporting(E_ALL);

include("./config.inc.php");
include("./libraries/functions.inc.php");
include("./libraries/classes.php");
include("./libraries/image.classes.php");

setlocale (LC_TIME, $cfg['config_locale']);
include("./languages/".get_lang($cfg['config_language']).".php");

if($DEBUG) {
    foreach($_POST as $akey => $val)
        out("<b>$akey</b> = $val", "OUT_DEBUG");
}

$id = intval($_GET['id']);
$file = strip_tags($_GET['file']);
$type = strip_tags($_GET['type']);
$title_opt = strip_tags($_GET['title_opt']);
$title = strip_tags($_GET['title']);
$desc_opt = strip_tags($_GET['desc_opt']);
$description = strip_tags($_GET['description']);
$gpx_id = intval($_GET['gpx_id']);

// connect to database
$link = db_connect_h($cfg['db_host'], $cfg['db_name'], $cfg['db_user'], $cfg['db_password']);


if($type) {
	// set headers for XML Http Request response
	header('Content-type: text/xml');
	header('Cache-Control: must-revalidate, pre-check=0, no-store, no-cache, max-age=0, post-check=0');

	
	switch ($type) {
		// import GPX XML files		
		case 'gpx':
			if($DEBUG) {
				sleep(2);
				$status = array('error'=>'-1', 'lid'=>'99', 'msg'=>'just testing...');
			}else {
				$status = array();
				$status['error'] = -1; 
				if(file_exists($file)) {
			        // init and load gpx document
					$doc = new GpxDocument("1.0", "UTF-8");
					if($doc) {
						$doc->load($file);
						// validate XML
						#$cfg['validate_gpx_xml'] = FALSE;
						if(!$cfg['validate_gpx_xml'] || $doc->validateGPX()) {
							// import
							$status = $doc->importGPX($description, $option);
							// move file to gpx folder if import was successful
							if(!$status['error']) {
								if(copy($file, './files/'.basename($file))) {
									if($cfg['chmod_on_import']) {
										@chown($file, 0644);
										@chown('./files/'.basename($file), 0644);
									}
									unlink($file);
								}else
									$status['msg'] = _IMPORT_COPY_FAILED;
							}
						}else
							$status['msg'] = _TRC_NO_VALID_XML;
							
					}else
						$status['msg'] = _TRC_NO_PHP_DOM_EXT;
					
				}else
					$status['msg'] = _IMPORT_FILE_ERROR;
			}
			break;
		
		// import JPG photo files
		case 'photo':
			if($DEBUG) {
				sleep(2);
				$status = array('error'=>'-1', 'lid'=>'77', 'msg'=>'just testing...');
			}else {
				$status = array();
				$status['error'] = -1; 
				if(file_exists($file)) {
			        // init and load photo file
					$doc = new ImageFile();
					if($doc) {
						$doc->load($file);
						// import
						$status = $doc->importPhoto($gpx_id, $title_opt, $title, $desc_opt, $description, $option);
						// move file to photo folder if import was successful
						if(!$status['error']) {
							if(copy($file, './photos/'.basename($file))) {
								if($cfg['chmod_on_import']) {
									@chown($file, 0644);
									@chown('./photos/'.basename($file), 0644);
								}
								unlink($file);
							}else
								$status['msg'] = _IMPORT_COPY_FAILED;
						}
						
					}else
						$status['msg'] = _PHOTO_NO_PHP_GD2_EXT;
				
				}else
					$status['msg'] = _IMPORT_FILE_ERROR;
			}
			break;
	}
	
	
	// creating XML Http Request response
	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
	echo "<phpmygpx>\n";
	echo "  <import 
				type=\"".$type."\" 
				id=\"".$id."\" 
				file=\"".$file."\" 
				status=\"".$status['error']."\" 
				lid=\"".$status['lid']."\" 
				msg=\"".rawurlencode($status['msg'])."\" 
			/>\n";
	echo "</phpmygpx>\n";
}
?>