<?php
/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

define( '_VALID_OSM', TRUE );
define( '_PATH', './' );
$DEBUG = FALSE;
if($DEBUG) error_reporting(E_ALL);

session_start();

include("./config.inc.php");
include("./libraries/functions.inc.php");
include("./libraries/classes.php");
include("./libraries/html.classes.php");

setlocale (LC_TIME, $cfg['config_locale']);
include("./languages/".get_lang($cfg['config_language']).".php");
include("./head.html.php");

if($cfg['show_exec_time'])
    $startTime = microtime_float();

if($DEBUG) {
    foreach($_POST as $akey => $val)
        out("<b>$akey</b> = $val", "OUT_DEBUG");
}

$id = intval($_GET['id']);
$gpx = strip_tags($_GET['gpx']);
$f_lat = floatval($_GET['lat']);
$f_lon = floatval($_GET['lon']);
$zoom = intval($_GET['zoom']);
$marker = intval($_GET['marker']);
$poi = intval($_GET['poi']);

// connect to database
$link = db_connect_h($cfg['db_host'], $cfg['db_name'], $cfg['db_user'], $cfg['db_password']);

HTML::heading(_APP_NAME, 2);
HTML::main_menu();

$f_minlat = 0;
$f_maxlat = 0;
$f_minlon = 0;
$f_maxlon = 0;

if(!$zoom)	$zoom = 15;
if(!$f_lat || !$f_lon) {
	if($id) {
		if(!$gpx) {
			$query = "SELECT * FROM `${cfg['db_table_prefix']}gpx_files` 
						WHERE `id` = '$id' ;";
			$result = db_query($query);
			if($DEBUG)	out($query, 'OUT_DEBUG');
			if(mysql_num_rows($result)) {
				while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
					$gpx = $row['name'];
				}
			}
		}
		
	    $query = "SELECT `gpx_id`, 
			MIN(`latitude`) AS 'minlat', MAX(`latitude`) AS 'maxlat', AVG(`latitude`) AS 'avglat', 
			MIN(`longitude`) AS 'minlon', MAX(`longitude`) AS 'maxlon', AVG(`longitude`) AS 'avglon'
			FROM `${cfg['db_table_prefix']}gpx_import` WHERE `gpx_id` = '$id' GROUP BY `gpx_id` ;";
	    $result = db_query($query);
		if($DEBUG)	out($query, 'OUT_DEBUG');
	    if(mysql_num_rows($result)) {
	    	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
				$f_minlat = $row['minlat'] /1000000;
				$f_maxlat = $row['maxlat'] /1000000;
				$f_minlon = $row['minlon'] /1000000;
				$f_maxlon = $row['maxlon'] /1000000;
	    	}
		}
	}else {
		$f_lat = $cfg['home_latitude'];
		$f_lon = $cfg['home_longitude'];
		$zoom = $cfg['home_zoom'];
	}
}

/*   bring in the OpenLayers javascript library
	 (here we bring it from the remote site, but you could
	 easily serve up this javascript yourself)
	 URL: http://www.openlayers.org/api/OpenLayers.js */
if($cfg['use_local_libs'])
	echo '<script src="openlayers/OpenLayers.js"></script>';
else
	echo '<script src="http://www.openlayers.org/api/OpenLayers.js"></script>';

/*   bring in the OpenStreetMap OpenLayers layers.
	 Using this hosted file will make sure we are kept up
	 to date with any necessary changes
	 URL: http://www.openstreetmap.org/openlayers/OpenStreetMap.js */
if($cfg['use_local_libs'])
	echo '<script src="openlayers/OpenStreetMap.js"></script>';
else
	echo '<script src="http://www.openstreetmap.org/openlayers/OpenStreetMap.js"></script>';
?>
<script src="openlayers/OSM_LocalTileProxy.js"></script>
<script src="openlayers/GPX.js"></script>
<script src="openlayers/map.js"></script>
<script src="openlayers/photolayer.js"></script>
<script src="openlayers/hikinglayer.js"></script>

<!-- define a DIV into which the map will appear. Make it take up the whole window -->
<div id="mapcontainer">
<div style="width:100%; height:66%;" id="map"><div id="spinning"></div></div>
</div>

<img src="images/b_bookmark.png" />
<input type="hidden" name="url" id="bookmarklink" />
<a href="JavaScript:addBookmark();"><?= _MAP_ADD_BOOKM ?></a><br />
<img src="images/b_select.png" />
<a href="" id="searchlink"><?= _MAP_AREA_TRKPT ?></a><br />
<img src="images/icon_josm.png" />
<a target="josm" href="" id="josmlink"><?= _MAP_JOSM_EDIT ?></a><br />
<img src="images/icon_osb.png" />
<a target="osb" href="" id="osblink">OpenStreetBugs</a><br />
<img src="images/icon_keepright.png" />
<a target="keepright" href="" id="keeprightlink">keep right!</a><br />

<script type="text/javascript">
	createMap(
		<?php echo "
		$f_lat ,
		$f_lon ,
		$zoom ,
		$f_maxlat ,
		$f_maxlon ,
		$f_minlat ,
		$f_minlon ,
		'${gpx}',
		".intval($marker)." ,
		".intval($cfg['photo_features'])." ,
		".intval($cfg['local_tile_proxy'] && checkCapability('proxysimple'))."
		"; ?>
	);
</script>

<script type="text/javascript">
	function addBookmark() {
		bookmarkName = prompt("<?= _MAP_JS_BOOKM_NAME ?>", "");
		if(bookmarkName) {
			var bookmarkScript = "bookmark.php?task=add&name=" + 
				encodeURIComponent(bookmarkName) + "&url=";
			var bookmarkLink = String(document.getElementById('bookmarklink').value);
			document.location.href = bookmarkScript + encodeURIComponent(bookmarkLink);
		}
	}
</script>

<?php
if($cfg['show_exec_time']) {
    $endTime = microtime_float();
    $exectime = round($endTime - $startTime, 4);
}
include("./foot.html.php");
?>