<?php
/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

define( '_VALID_OSM', TRUE );
define( '_PATH', './' );
define( 'GPX_UPLOAD_DIR', './upload/');
$DEBUG = FALSE;
if($DEBUG) error_reporting(E_ALL);

session_start();

include("./config.inc.php");
include("./libraries/functions.inc.php");
include("./libraries/classes.php");
include("./libraries/html.classes.php");
include("./libraries/GeoCalc.class.php");
include("./traces.html.php");

setlocale (LC_TIME, $cfg['config_locale']);
include("./languages/".get_lang($cfg['config_language']).".php");
include("./head.html.php");

if($cfg['show_exec_time'])
    $startTime = microtime_float();

if($DEBUG) {
    foreach($_POST as $akey => $val)
        out("<b>$akey</b> = $val", "OUT_DEBUG");
}

$p = intval($_GET['p']);
$id = intval($_GET['id']);
$task = strip_tags($_GET['task']);
$option = strip_tags($_GET['option']);
$f_date = strip_tags($_GET['date']);
$f_lat = floatval($_GET['lat']);
$f_lon = floatval($_GET['lon']);
$f_lat_range = floatval($_GET['lat_range']);
$f_lon_range = floatval($_GET['lon_range']);
$description = strip_tags($_GET['description']);
$submit = strip_tags($_POST['submit']);
$confirm = strip_tags($_POST['confirm']);

// convert lat/lon from float value to database integer format
if($option == "search") {
	$option = "filter";
	$f_lat *= 1000000; 
	$f_lon *= 1000000; 
	$f_lat_range *= 1000000; 
	$f_lon_range *= 1000000; 
}

// connect to database
$link = db_connect_h($cfg['db_host'], $cfg['db_name'], $cfg['db_user'], $cfg['db_password']);

HTML::heading(_APP_NAME, 2);
HTML::main_menu();

switch ($task) {
	case 'gpx':
		viewGPX($p);
		break;

	case 'details':
		details($id);
		break;

	case 'view':
		viewTrace($id, $p);
		break;

	case 'upload':
		uploadTrace();
		break;

	case 'batchimport':
		batchimportTraces();
		break;

	case 'import':
		importTrace();
		break;

	case 'edit':
		editTrace($id, $submit);
		break;

	case 'delete':
		deleteTrace($id, $submit, $confirm);
		break;

	case 'searchGPX':
		searchGPX();
		break;

	case 'searchTP':
		searchTP();
		break;

	default:
        viewTrace(NULL, NULL);
		break;
}


function viewGPX($page) {
	global $DEBUG, $cfg;
	global $option, $description;
    HTML::heading(_MENU_GPX_VIEW, 3);
	$search_url = "";
	$limit = $cfg['result_table_limit'];
    $query = "SELECT SQL_CALC_FOUND_ROWS * FROM `${cfg['db_table_prefix']}gpx_files` ";
	if($option == "filter") {
		$query .= "WHERE `description` LIKE '%".db_escape_string($description)."%' ";
		$search_url = "&option=filter&description=$description";
	}
	$query .= "ORDER BY `id` ASC LIMIT ". ($page*$limit) .", $limit ;";
    $result = db_query($query);
	if($DEBUG)	out($query, 'OUT_DEBUG');
    if(mysql_num_rows($result)) {
		$num_found = mysql_result(db_query("SELECT FOUND_ROWS();") ,0);
		HTML::viewPagination($page, ceil($num_found/$limit), 
			'traces.php?task=gpx'.$search_url);
		HTML_traces::viewGpxTableHeader();
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$query2 = "SELECT MIN(`timestamp`) AS 'mints', MAX(`timestamp`) AS 'maxts' 
						FROM `${cfg['db_table_prefix']}gpx_import` 
						WHERE `gpx_id` = '$row[id]';";
			$result2 = db_query($query2);
			$row2 = mysql_fetch_array($result2, MYSQL_ASSOC);
			// append gpx begin/end timestamps to array
			$row['mints'] = $row2['mints'];
			$row['maxts'] = $row2['maxts'];
			HTML_traces::viewGpxTableRow($row);
		}
		HTML_traces::viewGpxTableFooter();
		HTML::viewPagination($page, ceil($num_found/$limit), 
			'traces.php?task=gpx'.$search_url);
		HTML::message($num_found ._DB_GPX_AVAILABLE);
	}
	else
		HTML::message(_TRC_NO_GPX_IN_DB);
}

function details($id) {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_DETAILS, 3);
    #HTML::message(_TRC_DETAILS_OF_GPX . $id);
    $query = "SELECT * FROM `${cfg['db_table_prefix']}gpx_files` WHERE `id` = '$id' ;";
    $result = db_query($query);
	if($DEBUG)	out($query, 'OUT_DEBUG');
    if(mysql_num_rows($result)) {
    	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			HTML_traces::viewGpxDetails($row);
    	}
	    $query = "SELECT `gpx_id`, COUNT(*) AS 'trkpts', 
			MIN(`latitude`) AS 'minlat', MAX(`latitude`) AS 'maxlat', AVG(`latitude`) AS 'avglat', 
			MIN(`longitude`) AS 'minlon', MAX(`longitude`) AS 'maxlon', AVG(`longitude`) AS 'avglon',
			MIN(`altitude`) AS 'minalt', MAX(`altitude`) AS 'maxalt', AVG(`altitude`) AS 'avgalt', 
			MIN(`timestamp`) AS 'mints', MAX(`timestamp`) AS 'maxts',
			MIN(`sat`) AS 'minsat', MAX(`sat`) AS 'maxsat', AVG(`sat`) AS 'avgsat', 
			MIN(`hdop`) AS 'minhdop', MAX(`hdop`) AS 'maxhdop', AVG(`hdop`) AS 'avghdop', 
			MIN(`pdop`) AS 'minpdop', MAX(`pdop`) AS 'maxpdop', AVG(`pdop`) AS 'avgpdop'
			FROM `${cfg['db_table_prefix']}gpx_import` WHERE `gpx_id` = '$id' GROUP BY `gpx_id` ;";
	    $result = db_query($query);
		if($DEBUG)	out($query, 'OUT_DEBUG');
	    if(mysql_num_rows($result)) {
	    	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
				$trkptStats = $row;
	    	}
		}
	    $query = "SELECT COUNT(*) AS 'wpts' FROM `${cfg['db_table_prefix']}waypoints` 
	    			WHERE `gpx_id` = '$id' ;";
	    $result = db_query($query);
		if($DEBUG)	out($query, 'OUT_DEBUG');
	    if(mysql_num_rows($result)) {
	    	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
				$trkptStats['wpts'] = $row['wpts'];
	    	}
	    }
	    HTML_traces::viewGpxDetailsTable($trkptStats);
	
		// track distance calculation
		$stw = microtime_float();
		$distances = Trip::getDistancesArray($id);
		if($DEBUG)
			out("(dist calc took ". round(microtime_float() - $stw, 4) ." s)", 'OUT_DEBUG');
		HTML_traces::viewGpxDistances($distances);
		
		// split elevation chart if breaks found
		if(sizeof($distances) > 2)
			HTML::message(_TRC_DETAILS_CHART_SPLIT);
		
		foreach($distances as $key=>$val) {
			if(!$key)
				continue;
			if($cfg['chart_altitude_type'] == 'dist')
				$charttype = 'alt_dist';
			else
				$charttype = 'alt_time';
			
			echo '<a href="./graph.php?type='.$charttype.'&id='.$id.
			'&bts='.$distances[$key-1][2].'&ets='.$val[1].
			'&width='.$cfg['chart_big_width'].'&height='.$cfg['chart_big_height'].'">
			<img src="./graph.php?type='.$charttype.'&id='.$id.
			'&bts='.$distances[$key-1][2].'&ets='.$val[1].
			'&width='.$cfg['chart_width'].'&height='.$cfg['chart_height'].'"'.
			'width="'.$cfg['chart_width'].'" height="'.$cfg['chart_height'].'" '.
			'border="1" alt="GPX Altitude Profile" /></a>';
		}
    }else {
		HTML::message(_TRC_GPX_DOES_NOT_EXIST);
		return 1;
    }
}

function viewTrace($id, $page) {
	global $DEBUG, $cfg;
	global $option, $f_date, $f_lat, $f_lon, $f_lat_range, $f_lon_range;
	HTML::heading(_MENU_TRKPT_VIEW, 3);
	$search_url = "";
	$limit = $cfg['result_table_limit'];
	$query = "SELECT SQL_CALC_FOUND_ROWS * FROM `${cfg['db_table_prefix']}gpx_import` ";
	if($id)
		$query .= "WHERE `gpx_id` = '$id' ";
	if($option == "filter") {
		$query .= "WHERE 1 ";
		if($f_date)
			$query .= "AND DATE(`timestamp`) = '$f_date' ";
		if($f_lat)
			$query .= "AND `latitude` BETWEEN '$f_lat'-'$f_lat_range' 
					AND '$f_lat'+'$f_lat_range' ";
		if($f_lon)
			$query .= "AND `longitude` BETWEEN '$f_lon'-'$f_lon_range' 
					AND '$f_lon'+'$f_lon_range' ";

		$search_url = "&option=filter&date=$f_date&lat=$f_lat&lon=$f_lon&lat_range=$f_lat_range&lon_range=$f_lon_range";
	}
	$query .= "ORDER BY `timestamp` LIMIT ". ($page*$limit) .", $limit ;";
    $result = db_query($query);
	if($DEBUG)	out($query, 'OUT_DEBUG');
    if(mysql_num_rows($result)) {
		$num_found = mysql_result(db_query("SELECT FOUND_ROWS();") ,0);
		HTML::viewPagination($page, ceil($num_found/$limit), 
			"traces.php?task=view&id=$id".$search_url);
		HTML_traces::viewTraceTableHeader();
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			HTML_traces::viewTraceTableRow($row);
		}
		HTML_traces::viewTraceTableFooter();
		HTML::viewPagination($page, ceil($num_found/$limit), 
			"traces.php?task=view&id=$id".$search_url);
		HTML::message($num_found ._DB_TRKPTS_AVAILABLE);
		if($option == "filter") {
			HTML::message("<a href='export.php?type=trackpoints$search_url'>". _TRC_EXPORT_AS_GPX ."</a>");
		}
	}
	else
		HTML::message(_TRC_NO_TRKPTS_IN_DB);
}

function uploadTrace() {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_UPL, 3);
    if(!$cfg['public_host'] || check_password($cfg['admin_password'])) {
    	HTML_traces::fileUploadForm('traces.php?task=import', $cfg['max_file_size']);
    }else {
    	HTML::message(_NOT_AUTH ." ". _DO_LOGIN);
    }
}

function batchimportTraces() {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_BATCH_IMPORT, 3);
    if(!$cfg['public_host'] || check_password($cfg['admin_password'])) {
	    echo "<script src='./libraries/import.js'></script>\n";
	    // set current upload dir and scan it for gpx files
		$dir = GPX_UPLOAD_DIR;
		$gpx_files = scan_dir_f($dir, 0, 'FILETYPE_FILE', 'GPX');
		
		HTML::message_r(_TRC_BATCH_IMPORTING_DIR, $dir);
		HTML::message(_TRC_CHOOSE_FILES_FOR_BATCH_IMPORTING);
		if($DEBUG)	print_r($gpx_files);
		
		HTML_traces::viewBatchImportTableHeader();
		for($i=0; $i<sizeof($gpx_files); $i++) {
			HTML_traces::viewBatchImportTableRow($i+1, $gpx_files[$i]);
		}
		HTML_traces::viewBatchImportTableFooter($dir);
		HTML_traces::viewImportProgress();
    }else {
    	HTML::message(_NOT_AUTH ." ". _DO_LOGIN);
    }
}

function importTrace() {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_IMPORT, 3);
    if(!$cfg['public_host'] || check_password($cfg['admin_password'])) {
	    echo "<script src='./libraries/import.js'></script>\n";
		if($DEBUG) {
		    out($_FILES['userfile']['name'] ." (file name)", 'OUT_DEBUG');
		    out($_FILES['userfile']['size'] ." Bytes (size)", 'OUT_DEBUG');
		    out($_FILES['userfile']['error'] ." (error number)", 'OUT_DEBUG');
		}
		// set current upload dir and move file there
		$dir = GPX_UPLOAD_DIR;
		$file = $dir. $_FILES['userfile']['name'];
		
	    if(!move_uploaded_file($_FILES['userfile']['tmp_name'], $file))
	    	HTML::message(_TRC_UPL_ERROR . $_FILES['userfile']['error']);
	    else {
	    	HTML::message(_TRC_UPL_SUCCESS);
			HTML_traces::viewImportForm(1, basename($file), $dir, 
				strip_tags($_POST['description']));
			HTML_traces::viewImportProgress();
		}
    }else {
    	HTML::message(_NOT_AUTH ." ". _DO_LOGIN);
    }
}

function editTrace($id, $submit) {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_EDIT, 3);
    if(!$cfg['public_host'] || check_password($cfg['admin_password'])) {
	    if(!$submit) {
	        $query = "SELECT * FROM `${cfg['db_table_prefix']}gpx_files` 
	        	WHERE `id` = '$id' ;";
	        $result = db_query($query);
	        $row = mysql_fetch_array($result, MYSQL_ASSOC);
	    	if(mysql_num_rows($result))
	    		HTML_traces::editForm('traces.php?task=edit&id='.$id, $id, $row);
		    else
				HTML::message(_TRC_GPX_DOES_NOT_EXIST);
	    } else {
			// edit description of gpx file
			$description = db_escape_string(strip_tags($_POST['description']));
	        $query = "UPDATE IGNORE `${cfg['db_table_prefix']}gpx_files` 
	        	SET `description` = '$description' WHERE `id` = '$id' ;";
	        $result = db_query($query);
	        if(mysql_affected_rows()) {
	        	HTML::message(_TRC_GPX_EDITED);
	        	HTML::message("<a href='?task=details&id=${id}'>"._MENU_GPX_DETAILS."</a>");
	        }
	    }
    }else {
    	HTML::message(_NOT_AUTH ." ". _DO_LOGIN);
    }
}

function deleteTrace($id, $submit, $confirm) {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_DELETE, 3);
    if(!$cfg['public_host'] || check_password($cfg['admin_password'])) {
	    if(!$submit) {
	    	HTML_traces::deleteForm('traces.php?task=delete&id='.$id, $id);
	    } else {
			if($confirm == _CMN_YES) {
				// delete waypoints
		        $query = "DELETE IGNORE FROM `${cfg['db_table_prefix']}waypoints` 
		        	WHERE `gpx_id` = '$id' ;";
		        $result = db_query($query);
		        $num_rows = mysql_affected_rows();
		        HTML::message_r(_TRC_WPT_DELETED, $num_rows);
	
				// delete track points
		        $query = "DELETE IGNORE FROM `${cfg['db_table_prefix']}gpx_import` 
		        	WHERE `gpx_id` = '$id' ;";
		        $result = db_query($query);
		        $num_rows = mysql_affected_rows();
		        HTML::message_r(_TRC_TRKPT_DELETED, $num_rows);
	
				// delete gpx file
		        $query = "DELETE IGNORE FROM `${cfg['db_table_prefix']}gpx_files` 
		        	WHERE `id` = '$id' ;";
		        $result = db_query($query);
		        $num_rows = mysql_affected_rows();
		        HTML::message_r(_TRC_GPX_DELETED, $num_rows);
			} else {
				HTML::message(_TRC_NO_CONFIRM_DELETE);
			}    
	    }
    }else {
    	HTML::message(_NOT_AUTH ." ". _DO_LOGIN);
    }
}

function searchGPX() {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_GPX_SEARCH, 3);
    HTML_traces::searchGpxForm('');
}

function searchTP() {
	global $DEBUG, $cfg;
    HTML::heading(_MENU_TRKPT_SEARCH, 3);
    HTML_traces::searchTrkPtForm('');
}


if($cfg['show_exec_time']) {
    $endTime = microtime_float();
    $exectime = round($endTime - $startTime, 4);
}
include("./foot.html.php");
?>